diff -ruN uppsrc/CodeEditor/CodeEditor.h uppsrc/CodeEditor/CodeEditor.h
--- uppsrc/CodeEditor/CodeEditor.h	2013-05-26 23:17:50 +0400
+++ uppsrc/CodeEditor/CodeEditor.h	2013-08-17 08:44:49 +0400
@@ -432,7 +432,7 @@
 	const HlStyle& GetHlStyle(int i);
 	void           SetHlStyle(int i, Color c, bool bold = false, bool italic = false, bool underline = false);
 
-	void   CloseFindReplace();
+	void   CloseFindReplace(bool force = false);
 	void   FindReplace(bool pick_selection, bool pick_text, bool replace);
 	bool   Find(bool back, const wchar *text, bool wholeword, bool ignorecase, bool wildcards,
 	            bool block);
diff -ruN uppsrc/CodeEditor/FindReplace.cpp uppsrc/CodeEditor/FindReplace.cpp
--- uppsrc/CodeEditor/FindReplace.cpp	2013-05-06 05:42:00 +0400
+++ uppsrc/CodeEditor/FindReplace.cpp	2013-08-17 08:54:41 +0400
@@ -436,13 +436,13 @@
 	findreplace.findback.Show();
 	findreplace.ok.SetLabel("Find Next");
 	findreplace.ok <<= THISBACK(DoFind);
-	findreplace.cancel <<= findreplace.WhenClose = callback(&findreplace, &TopWindow::Close);
+	findreplace.cancel <<= findreplace.WhenClose = THISBACK1(CloseFindReplace, true);
 	findreplace.Open();
 }
 
 void CodeEditor::FindReplace(bool pick_selection, bool pick_text, bool replace)
 {
-	CloseFindReplace();
+	CloseFindReplace(true);
 	replacei = 0;
 	findreplace.CenterOwner();
 	WString find_text;
@@ -595,9 +595,9 @@
 	}
 }
 
-void CodeEditor::CloseFindReplace()
+void CodeEditor::CloseFindReplace(bool force)
 {
-	if(!persistent_find_replace && findreplace.IsOpen())
+	if(findreplace.IsOpen() && (force || !persistent_find_replace))
 		findreplace.Close();
 }
 
diff -ruN uppsrc/RichEdit/Editor.cpp uppsrc/RichEdit/Editor.cpp
--- uppsrc/RichEdit/Editor.cpp	2013-05-06 05:42:00 +0400
+++ uppsrc/RichEdit/Editor.cpp	2013-08-17 09:02:17 +0400
@@ -693,7 +693,7 @@
 	paintcarect = false;
 
 	CtrlLayoutOKCancel(findreplace, t_("Find / Replace"));
-	findreplace.cancel <<= callback(&findreplace, &TopWindow::Close);
+	findreplace.cancel <<= THISBACK1(CloseFindReplace, true);
 	findreplace.ok <<= THISBACK(Find);
 	findreplace.amend <<= THISBACK(Replace);
 	notfoundfw = found = false;
diff -ruN uppsrc/RichEdit/Find.cpp uppsrc/RichEdit/Find.cpp
--- uppsrc/RichEdit/Find.cpp	2013-05-06 05:42:00 +0400
+++ uppsrc/RichEdit/Find.cpp	2013-08-17 09:00:16 +0400
@@ -9,9 +9,9 @@
 		findreplace.replace.AddHistory();
 }
 
-void RichEdit::CloseFindReplace()
+void RichEdit::CloseFindReplace(bool force)
 {
-	if(!persistent_findreplace && findreplace.IsOpen())
+	if(findreplace.IsOpen() && (force || !persistent_findreplace))
 		findreplace.Close();
 }
 
diff -ruN uppsrc/RichEdit/RichEdit.h uppsrc/RichEdit/RichEdit.h
--- uppsrc/RichEdit/RichEdit.h	2013-05-06 05:42:00 +0400
+++ uppsrc/RichEdit/RichEdit.h	2013-08-17 08:59:36 +0400
@@ -583,7 +583,7 @@
 	void     CellProperties();
 
 	void     OpenFindReplace();
-	void     CloseFindReplace();
+	void     CloseFindReplace(bool force = false);
 	int      FindPos();
 	RichText ReplaceText();
 	void     Find();
